#!/bin/sh
# Enable shadowing for all files/symlinks in
#  /alt

ALTSHADOW=/usr/local/sbin/altshadow

case "$1" in

start)
	echo 'Shadowing all files from /alt...'
	ROOTDEV=$(cat /proc/cmdline | sed -e 's/.*root=//' -e 's/[ ,].*//' )
	ALTDEV=$(( ${ROOTDEV#${ROOTDEV%?}} + 1 ))
	if ! mount -t jffs2 /dev/mtdblock${ALTDEV} /alt ; then 
		echo "Shadowing failed! Cannot find jffs2 at /dev/mtdblock${ALTDEV}"
		exit 1
	fi
	if grep -q '/alt' /proc/mounts; then
		find /alt -type f | sed -e 's/\/alt//' | xargs ${ALTSHADOW} /alt 
		if [ ! -e /alt/etc/pointercal ] && [ ! -e /etc/pointercal ]; then
			ln -s /alt/etc/pointercal /etc/pointercal
		fi
	else
		echo '/alt not mounted - shadowing aborted!'
		exit 1
	fi
	;;

stop)
	echo 'Updating /alt with shadowed files...'
	if grep -q '/alt' /proc/mounts; then
		for file in $(find /alt -type f | sed -e 's/\/alt//'); do
			if [ -e "$file" ] && [ ! -L "$file" ]; then
				cp -a "$file" "/alt/$file"
			fi
		done
	else
		echo '/alt not mounted - aborted!'
		exit 1
	fi
	;;

*)
	;;
esac
